<?php
# structuring json-string

# naively assumes that there's no [{,}] inside of strings

$jsfn = $_SERVER['argv'][1];
$json = file_get_contents($jsfn);

$a1 = array('/[[{,]/', '/[]}]/', "/\[\n\n\]/", "/},\n{/");
$a2 = array("$0\n"   , "\n$0"  , '[]'        , "},{");

$j2 = preg_replace($a1, $a2, $json);

$j3 = indent($j2, 4, '/[[{]$/', '/^[]}]/');
#die(substr($j3, 0, 2000));
echo $j3;


function indent($s, $n, $rx1, $rx2) {
    $LL = $wsp0 = '          ';
    for($i=0; $i<9; $i++)
        $LL .= $wsp0;

    $a = explode("\n", $s);
    $lvl = 0;
    foreach($a as &$line) {
        if(preg_match($rx2, $line)) $lvl--;
        $pre = substr($LL, 0, $n * $lvl);
        if(preg_match($rx1, $line)) $lvl++;
        $line = $pre . $line;
    }
    return implode("\n", $a);
}